from flask import Flask, render_template, request
import jwt
import json

app = Flask(__name__)
# remember to use DEBUG mode for templates auto reload
# https://github.com/lepture/python-livereload/issues/144
app.debug = True

secret = "[5p)RNk166!by&]6Sg-fT?x^B/&B%Yv0D5jR(33?3y2%gD8o#(EX3AT?g2AE-_Q"

def merge_dicts(*dict_args):
    """
    Given any number of dicts, shallow copy and merge into a new dict,
    precedence goes to key value pairs in latter dicts.
    """
    result = {}
    for dictionary in dict_args:
        result.update(dictionary)
    return result

def addNewStep(step, data):

    if len(data['data']) <= data['lastDayId']:
        data['data'].append([])

    data['lastStepIndex'] += 1
    data['data'][data['lastDayId']].append(step)

    if data['lastStepIndex'] > len(data['sections']['names']):
        data['lastDayId'] += 1
        data['lastStepIndex'] = 0

    return data

@app.route("/init", methods=['POST'])
def initToken():

    options = request.form.get('data', None)

    if not (options):
        return "Missing parameter", 400

    options = json.loads(options)

    data = {
        'data' : [[]],
        'lastDayId' : 0,
        'lastStepIndex' : 0
    }

    for option in options.keys():
        data = merge_dicts(data, {option :  options[option]})

    return jwt.encode( data, secret, algorithm='HS256')

@app.route("/sections", methods=['POST'])
def sections():

    sections = request.form.get('data', None)
    token = request.form.get('jwt', None)

    if not (sections and jwt and token):
        return "Missing parameter", 400

    sections = json.loads(sections)

    data = jwt.decode(token, secret)

    data['sections'] = {
        'data' : sections['data'],
        'names' : sections['names']
    }

    token = jwt.encode(data, secret, algorithm='HS256')

    return token

@app.route("/click", methods=['POST'])
def click():

    timestamp = request.form.get('time', None)
    token = request.form.get('jwt', None)

    if not (timestamp and jwt ):
        return "Missing parameter", 400

    data =  jwt.decode(token, secret)

    steps = addNewStep(timestamp, data)

    token = jwt.encode( steps, secret, algorithm='HS256')

    return token

@app.route("/", methods=['GET'])
def index():
    return render_template('index.html')

if __name__ == "__main__":
    app.run(port=8082)
